#include "FiveWin.Ch"

#define CLR_ROTMETRO		RGB( 191,  30,  75 )

//----------------------------------------------------------------------------//
REQUEST DBFCDX
//----------------------------------------------------------------------------//

function Main(cAufruf)
	local aData
	local oDlg, oFont, oBrw, n, oFontBrw, oBTNSave
	local nWidth   := GetSysMetrics( 0 ) * 0.9
	local nHeight  := GetSysMetrics(1 ) * 0.9
	local cTitle   := "/i zi' pi zi/   ***** Reportgenerator"
	local nOffset  := 0
	local oBtn
	local oFontFLATBTN
	local aReportData	:= {}
	local I 			:= 0
	*----------------------------------------------------------
	DEFINE FONT oFont NAME 'TAHOMA' SIZE 0,-18
	DEFINE FONT oFontFLATBTN NAME 'TAHOMA' SIZE 0,-18
	DEFINE FONT oFontBrw NAME 'TAHOMA' SIZE 0,-26
	
	aData := {}
	
	AADD(aData, { "[YourCompanyName]", "T M Byxbee Company Pc" } ) 
	AADD(aData, {"[YourBusinessAddress]", "322 New Horizon Blvd" } ) 
	AADD(aData, {"[yourCity]", "Roma" } ) 
	AADD(aData, {"[yourCountry]", "WI" } ) 
	AADD(aData, {"[Postal]", "http://www.tmbyxbeecompanypc.com" } )
	
	AADD(aData, {"[CompanyName]", "Cindy Turner Associates" } ) 
	AADD(aData, {"[Address]", "20 S Babcock S" } ) 
	AADD(aData, {"[City]", "Milano" } ) 
	AADD(aData, {"[Country]", "AK" } ) 
	
	AADD(aData, {"[invoiceNr]", "98487112" } ) 
	AADD(aData, {"[date]", "29-07-2021" } ) 
	AADD(aData, {"[duedate]", "26-07-2021" } ) 	
	
	AADD(aData, {"[notes]", "The seller is responsible for loading the goods onto the truck" } ) 
	AADD(aData, {"[total]", "  20,000,-" } ) 
	AADD(aData, {"[MyReport]", "Test Marco" } ) 
	AADD(aData, {"[Textblock]", "Test Marco" } ) 
	
	AADD(aData, {"[TOTALINVOICE]", "&euro;2.900,00" } ) 
	 
	
	FOR I := 1 to len( aReportData )
		aReportData[I,2] += space(300)
	NEXT
	
	DEFINE DIALOG oDlg SIZE nWidth, nHeight PIXEL FONT oFont TRUEPIXEL
	
	@ 20,20 SAY cTitle OF oDlg PIXEL FONT oFontBrw SIZE 800, 40
	
	@ 80,50 ;
		XBROWSE oBrw ;
			 OF oDlg ;
		  PIXEL ;
		   SIZE nWidth-200, nHeight -250 ;
	 DATASOURCE aData ;
		HEADERS "Key","Value" ;
	   COLSIZES 250,500,150,500 ;
	   AUTOCOLS ;
	   FASTEDIT ;
		  LINES ;
	   NOBORDER
   
	
	WITH OBJECT oBrw
	WITH OBJECT :oCol( 1 )
	:oDatafont  := oFont
END
 

:l2007 := .T.
:lExcelCellwise   := .F.
:lFreezeLikeExcel := .F.

END

oBrw:CreateFromCode()

nOffSet := If( oBtn == nil, 25, nOffSet + 15 + oBtn:nWidth ) 
nPixPerChar := GetTextWidth( oDlg:hWnd,"Run" ,  oFontFLATBTN:hFont )  + 30 
@ oDlg:nHeight - 70, nOffset BTNBMP oBtn PROMPT "Run" SIZE nPixPerChar, 52 PIXEL OF oDlg FLAT COLOR  CLR_WHITE, CLR_ROTMETRO ACTION Report( oBrw )

ACTIVATE DIALOG oDlg CENTERED ON INIT ( oBrw:SetFocus(), .f. )

RELEASE FONT oFont
RELEASE FONT oFontBrw
RELEASE FONT oFontFLATBTN
return (0)

//----------------------------------------------------------------------------//

static function Report( oBrw )
	
	local aLine
	local cHtml := ""
	local I := 1
	local cText := ""
	local cTextIni
	local aReport := {}
	local cPRGPATH := cFILEPATH( GETMODULEFILENAME( GETINSTANCE() ) )
	local cHtmlOrUrl :=  cPRGPATH + "index.html"
	*----------------------------------------------------------
	
	//Your ARRAY 	
	//AADD( aReport , {  } )
	AADD( aReport , {  "Clip2.jpg",	"Ombrellone 0006","1", "9.00",	"9.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00"  } )
	AADD( aReport , {  "Clip3.jpg",	"Lettino",			"1", "5.00", "5.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00" } )
	AADD( aReport , {  "Clip4.jpg",	"Sdraio",			"2", "6.00", "6.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00" } )
	
	AADD( aReport , {  "Clip2.jpg",	"Ombrellone 0006","1", "9.00",	"9.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00"  } )
	AADD( aReport , {  "Clip3.jpg",	"Lettino",			"1", "5.00", "5.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00" } )
	AADD( aReport , {  "Clip4.jpg",	"Sdraio",			"2", "6.00", "6.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00" } )
	
	AADD( aReport , {  "Clip2.jpg",	"Ombrellone 0006","1", "9.00",	"9.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00"  } )
	AADD( aReport , {  "Clip3.jpg",	"Lettino",			"1", "5.00", "5.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00" } )
	AADD( aReport , {  "Clip4.jpg",	"Sdraio",			"2", "6.00", "6.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00" } )
	
	AADD( aReport , {  "Clip2.jpg",	"Ombrellone 0006","1", "9.00",	"9.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00"  } )
	AADD( aReport , {  "Clip3.jpg",	"Lettino",			"1", "5.00", "5.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00" } )
	AADD( aReport , {  "Clip4.jpg",	"Sdraio",			"2", "6.00", "6.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00" } )
	
	AADD( aReport , {  "Clip2.jpg",	"Ombrellone 0006","1", "9.00",	"9.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00"  } )
	AADD( aReport , {  "Clip3.jpg",	"Lettino",			"1", "5.00", "5.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00" } )
	AADD( aReport , {  "Clip4.jpg",	"Sdraio",			"2", "6.00", "6.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00" } )
	
	AADD( aReport , {  "Clip2.jpg",	"Ombrellone 0006","1", "9.00",	"9.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00"  } )
	AADD( aReport , {  "Clip3.jpg",	"Lettino",			"1", "5.00", "5.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00" } )
	AADD( aReport , {  "Clip4.jpg",	"Sdraio",			"2", "6.00", "6.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00" } )
	
	AADD( aReport , {  "Clip2.jpg",	"Ombrellone 0006","1", "9.00",	"9.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00"  } )
	AADD( aReport , {  "Clip3.jpg",	"Lettino",			"1", "5.00", "5.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00" } )
	AADD( aReport , {  "Clip4.jpg",	"Sdraio",			"2", "6.00", "6.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00" } )
	
	AADD( aReport , {  "Clip2.jpg",	"Ombrellone 0006","1", "9.00",	"9.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00"  } )
	AADD( aReport , {  "Clip3.jpg",	"Lettino",			"1", "5.00", "5.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00" } )
	AADD( aReport , {  "Clip4.jpg",	"Sdraio",			"2", "6.00", "6.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00" } )
	
	AADD( aReport , {  "Clip2.jpg",	"Ombrellone 0006","1", "9.00",	"9.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00"  } )
	AADD( aReport , {  "Clip3.jpg",	"Lettino",			"1", "5.00", "5.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00" } )
	AADD( aReport , {  "Clip4.jpg",	"Sdraio",			"2", "6.00", "6.00", "08-Lug-2021",	"08-Lug-2021","" , "0.00",  "0.00" } )
	
	
	
	*----------------------------------------------------------
	* START REPORT
	*----------------------------------------------------------
	
	//Standard Definition
	cTextIni := memoread(".\invoice\invoice1.htm")
	cHtml += cTextIni
	
	//read table style
	cTextIni := memoread(".\invoice\tablestyle.html")
	cHtml += cTextIni
	
	//read table style
	cTextIni := memoread(".\invoice\tablestart.html")
	cHtml += cTextIni	
	
	//Table Header	- put here your table header							
	cText += "<table class='table1' style='width:100%'>" + CRLF
	cText += "<tr>" + CRLF
	cText += check4prn( 1, "<th>Ico</th>" + CRLF )
	cText += check4prn( 2, "<th>Descrizione</th>" + CRLF )
	cText += check4prn( 3, "<th>Qt.</th>" + CRLF )
	cText += check4prn( 4, "<th>Unit.</th>" + CRLF )
	cText += check4prn( 5, "<th>ToxQt</th>" + CRLF )
	cText += check4prn( 6, "<th>Dal</th>" + CRLF )
	cText += check4prn( 7, "<th>Al</th>" + CRLF )
	cText += check4prn( 8, "<th>Giorni</th>" + CRLF )
	cText += check4prn( 9, "<th>Sconto</th>" + CRLF )
	cText += check4prn(10, "<th>Totale riga</th>" + CRLF )
	cText += "</tr>" + CRLF
	cHtml += cText
	
	//Table Row  - define your table row 
	FOR I := 1 to len(aReport)
		cText := "<tr>" + CRLF
		cText	+= check4prn( 1, "<td class='mytd'><IMG SRC='beach/" + aReport[I,1] +  "' NAME='Grafik1' ALIGN=BOTTOM WIDTH=20 HEIGHT=20 BORDER=0></td>" + CRLF )
		cText	+= check4prn( 2, "<td class='mytd'><b>" + aReport[I,2]  + "</b></td>" + CRLF )
		cText	+= check4prn( 3, "<td class='mytd'>" + aReport[I,3] + "</td>" + CRLF )
		cText	+= check4prn( 4, "<td class='mytd'>" + aReport[I,4] + "</td>" + CRLF )
		cText	+= check4prn( 5, "<td class='mytd'>" + aReport[I,5] + "</td>" + CRLF )
		cText	+= check4prn( 6, "<td class='mytd'>" + aReport[I,6] + "</td>" + CRLF )
		cText	+= check4prn( 7, "<td class='mytd'>" + aReport[I,7] + "</td>" + CRLF )
		cText	+= check4prn( 8, "<td class='mytd'>" + aReport[I,8] + "</td>" + CRLF )
		cText	+= check4prn( 9, "<td class='mytd'>" + aReport[I,9] + "</td>" + CRLF )
		cText	+= check4prn(10, "<td class='mytdr'>" + aReport[I,10] + "</td>" + CRLF )
		cText += "</tr>" + CRLF
		cHtml += cText
	next
	
	cHtml += "</table> "
	cTextIni := memoread(".\invoice\tablemarco.html")
	cHtml += cTextIni
	
	//Standard Definition
	cTextIni := memoread(".\invoice\footer .htm")
	cHtml += cTextIni
	
	//placeholders are substituted
	FOR I := 1 to len( oBrw:aArrayData )
		cHtml := STRTRAN( cHtml, oBrw:aArrayData[I,1], ALLTRIM( oBrw:aArrayData[I,2] ) )
	next
	 
	memowrit( cHtmlOrUrl, cHtml)
	PrintHtml( cHtmlOrUrl,1,.t.)
	oBrw:SetFocus()
	
return nil

//----------------------------------------------------------------------------//
#Define OLECMDID_PRINT                  6
#Define OLECMDEXECOPT_PROMPTUSER        1
#Define OLECMDEXECOPT_DONTPROMPTUSER    2
#Define OLECMDID_ENABLE_INTERACTION     36
#Define OLECMDID_PRINTPREVIEW           7
#Define OLECMDID_SAVEAS                 4
#Define OLECMDID_PAGESETUP              8
#Define OLECMDID_CUT                    11      //Shear
#Define OLECMDID_NEW                    2       //Create a new document
#Define OLECMDID_EXITFULLSCREEN    		 81
#Define OLECMDID_SAVE                   3       //Preservation

#Define OLECMDID_SETTITLE               28      //Fehler
#Define OLECMDID_ZOOM                   19

// enable print background and images in IE

function PrintHtml ( cHtmlOrUrl, nCopies,lShow )
	static  oIe, oWnd, oPrn
	local i
	*----------------------------------------------------------
	
	default lShow:=.f.,nCopies:=1
	oIe = TActiveX():New( NIL, "Shell.Explorer" )
	
	oIe:Do( "Navigate2", cHtmlOrUrl)
	
	do while alltrim(oIe:document:readyState) <> 'complete'
		sysrefresh()
		waitseconds(.5)
	enddo
	
	if lshow
		oIe:Do( "ExecWB", OLECMDID_PRINTPREVIEW, OLECMDEXECOPT_PROMPTUSER, OLECMDID_PAGESETUP, OLECMDID_CUT  )
	else
		for i=1 to nCopies
			msgwait('Printing large receipt (' + alltrim(str(i)) + ' of '+alltrim(str(nCopies))+' copies).',,2)
			oIe:Do( "ExecWB", OLECMDID_PRINT, OLECMDEXECOPT_DONTPROMPTUSER )
		next i
	endif
	
	sysrefresh()
	oIe:end()
RETURN nil
//----------------------------------------------------------------------------//


function check4prn( nCol, cCol )
	//               1234567890123456
	local cPrint := "JJJJJJJJJJJNNNNN"
	
	if substr(cPrint, nCol, 1 ) <> "J"
		cCol := ""
	endif
	
return( cCol )
//------------------------------------------------------------------------------------------//

init procedure PrgInit
	SET DATE ITALIAN
	SET CENTURY ON
	SET TIME FORMAT TO "HH:MM:SS"
	SET EPOCH TO YEAR(DATE())-50
	
	SET DELETED ON
	SET EXCLUSIVE OFF
	
	RDDSETDEFAULT( "DBFCDX" )
	
	XbrNumFormat( 'E', .t. )
	SetKinetic( .f. )
	SetGetColorFocus()
	
return

//----------------------------------------------------------------------------//

exit procedure PrgExit
	SET RESOURCES TO
return

//----------------------------------------------------------------------------//





















